unit unWideHash;

interface
uses classes,IDGlobal,sysutils;

type
    TozHashEntry = class(TObject)
       key : widestring;
       value : widestring;
    end;

    TozWideHash = class(TObject)
    private
       procedure addUrlParam(param : string);
    public
       items : TList;
       constructor create;
       destructor destroy; override;
       procedure add(key : widestring; value : widestring);
       function get(key : widestring) : widestring;
       procedure fromUrl(url : string);
    end;

implementation

constructor TozWideHash.Create;
begin
    items := TList.Create;
end;

destructor TozWideHash.destroy;
var
    x : integer;
begin
    for x := 1 to items.Count do begin
       TozHashEntry(items[x-1]).free;
    end;
    items.Free;
end;

procedure TozWideHash.add(key : widestring; value : widestring);
var
   he : TozHashEntry;
begin
   he := TozHashEntry.Create;
   he.key := key;
   he.value := value;
   items.Add(he);
end;

function TozWideHash.get(key : widestring) : widestring;
var
   found : boolean;
   x : integer;
   resp : widestring;
begin
   x := 0;
   found := false;
   resp := '';
   while ((x<items.Count) and (not found)) do begin
       if (TozHashEntry(items[x]).key = key) then begin
           found := true;
           resp := TozHashEntry(items[x]).value;
       end else inc(x);
   end;
   Result := resp;
end;

procedure TozWideHash.fromUrl(url : string);
var p1 : integer;
    param : string;
begin

    p1 := pos('&',url);
    while (p1>0) do begin
        param := copy(url,1,p1-1);
        addUrlParam(param);
        url := copy(url,p1+1,length(url)-p1);
        p1 := pos('&',url);
    end;
    param := url;
    addUrlParam(param);
end;

procedure TozWideHash.addUrlParam(param : string);
var
    p1 : integer;
    k,v : string;
    key : widestring;
    val : widestring;
begin
    key := '';
    val := '';
    p1 := pos('=',param);
    if (p1>0) then begin
       k := copy(param,1,p1-1);
       v := copy(param,p1+1,length(param)-p1);
       key := k;
       v := urldecode(v);
       val := utf8decode(v);
    end;
    if (key<>'') then add(key,val);
end;



end.
